'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _ths = require('ths');

var _ths2 = _interopRequireDefault(_ths);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _lodash = require('lodash');

var _proxySupply = require('./proxy-supply');

var _proxySupply2 = _interopRequireDefault(_proxySupply);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('debug')('tlaloc:cluster:thsInstance');

var THSInstance = function (_THS) {
  (0, _inherits3.default)(THSInstance, _THS);

  function THSInstance(_ref) {
    var dataDir = _ref.dataDir;
    var host = _ref.host;
    var port = _ref.port;
    var redis = _ref.redis;
    var ctrlPort = _ref.ctrlPort;
    var onTorError = _ref.onTorError;
    var onTorMessage = _ref.onTorMessage;
    (0, _classCallCheck3.default)(this, THSInstance);

    debug.apply(undefined, ['Creating instance'].concat(Array.prototype.slice.call(arguments)));

    _mkdirp2.default.sync(dataDir);


    // Remove erroneous services

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(THSInstance).call(this, dataDir, port, ctrlPort, onTorError, onTorMessage));

    _this.serviceName = 'port_' + port;
    _this.endpoint = host + ':' + port;
    _this.redis = redis;

    _this.getServices().filter(function (service) {
      return service.name !== _this.serviceName;
    }).forEach(function (service) {
      debug('Removing service ' + service.name);
      _this.removeHiddenService(service.name, true);
    });

    // Register this port's hidden service
    if (!(0, _lodash.find)(_this.getServices(), { name: _this.serviceName })) {
      _this.createHiddenService(_this.serviceName, port, true);
    }

    _this.proxy = new _proxySupply2.default({ endpoint: _this.endpoint });
    return _this;
  }

  (0, _createClass3.default)(THSInstance, [{
    key: 'connect',
    value: function connect() {
      var _this2 = this;

      return new _promise2.default(function (resolve, reject) {
        _this2.start(true, function (err) {
          if (err) return reject(err);
          resolve();
        });
      }).then(function () {
        return _this2.proxy.connect(_this2.redis);
      });
    }
  }, {
    key: 'disconnect',
    value: function disconnect() {
      var _this3 = this;

      this.proxy.disconnect();

      return new _promise2.default(function (resolve, reject) {
        _this3.stop(function (err) {
          if (err) return reject(err);
          resolve();
        });
      });
    }
  }]);
  return THSInstance;
}(_ths2.default);

exports.default = THSInstance;